<!DOCTYPE html>
<html>
<head>
	<meta charset="UTF-8">
	<title> Lesson 4 :: Task 3 </title>

	<link rel="stylesheet" href="css/normalize.css" />
	<link rel="stylesheet" href="css/style.css" />
	<!-- <script src='https://kit.fontawesome.com/a076d05399.js' crossorigin='anonymous'></script> -->

</head>
<body>
	<select class="form__input select" id="countries"></select>
	<div id="result"></div>

<script>
	/*
		Задание 3:

		1. Сгенерировать список стран в Select countries
		2. При выборе страны генерировать еще один Select со списком
		городов этой страны и вывести этот селект в блок result
		3. При выборе города нужно случайно рандомить температуру от
		-10 градусов до +40. Если температура

		-10 до 0 то 'Солнечно' 'Легкий снегопад' 'Сильный снегопад'
		0 до 30 то  'Солнечно' 'Дождь' 'Ветер' 'Сильный дождь'
		30 до 40 то 'Солнечно' 'Засуха' 'Ветер'

		4. Вывести сообщение на страничку
		{Country}. В {City} {Weather} {Temperature} градусов.
		Ukraine. В Kyiv Солнечно -10 градусов

		+ бонус: добавить красивые картинки с погодой
	*/
	document.addEventListener('DOMContentLoaded', function(){

		let countries = ['Ukraine', 'Poland', 'USA'];
		let ukraineCity = ['Kyiv', 'Lviv', 'Odesa', 'Charkiv'];
		let polandCity = ['Warszawa', 'Poznan', 'Krakow', 'Katowice'];
		let usaCity = ['New York', 'Los Angeles', 'Las Vegas', 'Chicago'];
		
		let selectedCountry = null;
		let selectedCity = null;
		let temperatureForecast = null;
		let weatherForecast = null;

		let result = document.getElementById("result")
		let cities = [ukraineCity, polandCity,usaCity]

		let selectCountries = document.getElementById("countries")
		
		let fragment = document.createDocumentFragment()
		
		let option = document.createElement("option")
			option.value = ""
			option.disabled = "disabled"
			option.selected = "selected"
			option.innerText = "Please select country"
			fragment.appendChild(option)

		countries.forEach((country, index) => {
			let option = document.createElement("option")
			option.value = index
			option.innerText = country
			fragment.appendChild(option)
		})
		selectCountries.appendChild(fragment)
		selectCountries.addEventListener("change", countryHandler)

		function countryHandler (e) {
			selectedCountry = selectCountries.value
			let selectCity = document.getElementById("selectCity")
			let needToInsert = true;
			if(selectCity) { 
				needToInsert = false;
				Array.from(selectCity.children).forEach(child => {selectCity.remove(child)})
			} else {
				selectCity = document.createElement("select")
				selectCity.id = "selectCity"
				selectCity.classList.add("form__input")
				selectCity.classList.add("select")
				selectCity.addEventListener("change", cityHandler)
			}

			let fragment = document.createDocumentFragment()

			let option = document.createElement("option")
			option.value = ""
			option.disabled = "disabled"
			option.selected = "selected"
			option.innerText = "Please select city"
			fragment.appendChild(option)

			cities[selectedCountry].forEach((city,index) => {
				let option = document.createElement("option")
				option.value = index
				option.innerText = city
				fragment.appendChild(option)
			})

			if (needToInsert) {
				selectCity.appendChild(fragment)
				document.body.insertBefore(selectCity, result)
			} else {
				selectCity.appendChild(fragment)
			}

		}

		function cityHandler(e) {
			let selectCity = document.getElementById("selectCity")
			selectedCity = selectCity.value;
			temperatureForecast = getRandTemperature()
			weatherForecast = getWeather(temperatureForecast)
			// let iWeather = document.createElement("i")
			// iWeather.classList.add("fas")
			// iWeather.classList.add("fa-cloud-showers-heavy")
			// result.appendChild(iWeather)
			// console.log(iWeather)
			resultString = `${countries[selectedCountry]}. В ${cities[selectedCountry][selectedCity]} ${weatherForecast} ${temperatureForecast} градусов.`
			result.innerHTML = resultString

		}

		let weatherTo0 = ['Солнечно', 'Легкий снегопад', 'Сильный снегопад']
		let weatherTo30 = [ 'Солнечно', 'Дождь', 'Ветер', 'Сильный дождь']
		let weatherTo40 = ['Солнечно', 'Засуха', 'Ветер']


		function getWeather(temperature) {
			let array = []
			if(temperature >= -10 && temperature <= 0 ) {
				array = weatherTo0
			} else if (temperature >0 && temperature <= 30 ) {
				array = weatherTo30
			} else if (temperature >30 && temperature <= 40 ) {
				array = weatherTo40
			}
			return getRandomFromArray(array)
		}


		function getRandTemperature() {
			return getRandomIntInclusive(-10,40)
		}
		function getRandomIntInclusive(min, max) {
			min = Math.ceil(min);
			max = Math.floor(max);
			return Math.floor(Math.random() * (max - min + 1)) + min;
		}
		function getRandomFromArray(array) {
		return array[getRandomIntInclusive(0, array.length -1)];
	}
	});

</script>
</body>
</html>